{"openapi":"3.0.0","info":{"version":"1.0.0","title":"3DC - Lowes Service Endpoints","description":"--- DRAFT API --- API documentation for Lowes service needs. These endpoints will be utilized by Lowes services to retrieve data needed by their CRM. This is a draft document and request / response objects are subject to change"},"servers":[{"description":"Production environment","url":"https://lowes-services.3dcloud.io"},{"description":"Certification/Staging environment","url":"https://lowes-services-cert.3dcloud.io"}],"components":{"securitySchemes":{"ApiKeyAuth":{"type":"apiKey","in":"header","name":"API_Key"}},"schemas":{"projectDetailsResponse":{"type":"object","description":"Provides manifest of project resources and details","properties":{"versions":{"description":"Details for each version of the specified project","type":"array","items":{"description":"Json object containing data for each project in the array","type":"object","properties":{"projectId":{"description":"Lowes project Entity id associated with the details","type":"string"},"leadId":{"description":"Lowes Lead id associated with the details","type":"string"},"projectUuid":{"description":"uuid of 3DC project associated with the details","type":"string","format":"uuid","example":"460181a4-1ac3-430e-879e-41ff5978effc"},"version":{"description":"the version of the project associate with the details","type":"number"},"clientId":{"description":"Lowes Client Id","type":"string","example":"000049"},"clientAppId":{"description":"Lowes Client App Id Associated with the request/project","type":"string","example":"000117"},"store":{"type":"object","properties":{"storeNumber":{"description":"Lowes store number associated with the project","type":"string"}}},"ownerId":{"description":"customer ID","type":"string"},"associateIds":{"description":"Array of Lowes associates that have edited the project","type":"array","items":{"type":"string"}},"quoteId":{"type":"string"},"isDeleted":{"type":"boolean"},"files":{"type":"array","items":{"type":"object","properties":{"type":{"type":"string","enum":["PANO","RENDER","BOM","SCREENSHOT","THUMBNAIL","BLUEPRINT","PRESENTATION","CUSTOMER","INSTALLER"]},"fileUrl":{"type":"string"},"createdTimestamp":{"type":"string","format":"date-time"},"detail":{"type":"string"},"status":{"type":"string"}}}}}}}}},"projectBOMResponse":{"type":"object","properties":{"projectUuid":{"description":"uuid of the project associated with the BOM data","type":"string","format":"uuid","example":"123e4567-e89b-12d3-a456-426614174000"},"version":{"description":"project version from which BOM data was taken (default is latest version)","type":"number","example":2},"products":{"type":"array","items":{"type":"object","properties":{"sku":{"description":"product SKU","type":"string","example":"1234650"},"name":{"description":"Text name of product","type":"string"},"description":{"description":"Text description of product","type":"string"},"quantity":{"description":"Number of occurences of product within the project","type":"integer"}}}}}},"LowesEventRequest":{"type":"object","required":["designType","eventType","version"],"properties":{"designType":{"$ref":"#/components/schemas/DesignType"},"eventType":{"type":"string","description":"Short string name of the event type"},"version":{"type":"integer","description":"The project version associated with the event","example":1},"designOrigin":{"type":"string","description":"Source of the design (e.g., mobile, desktop)"},"description":{"type":"string","description":"Additional details about the event"}}},"DesignType":{"type":"string","enum":["KITCHEN"]}}},"security":[{"ApiKeyAuth":[]}],"paths":{"/api/projects/v1/{projectUuid}/details":{"get":{"summary":"Get Details for Given Project","description":"Uses the provided projectUuid value to indicate the specific project for which to retrieve details. Authenticated using API KEY","tags":["Project Management"],"parameters":[{"name":"projectUuid","in":"path","required":true,"schema":{"type":"string","format":"uuid"}},{"name":"version","in":"query","required":false,"schema":{"type":"number","description":"specify the version of the project for which to specifically return"}}],"responses":{"401":{"description":"Invalid or missing API Key or Invalid or missing username"},"404":{"description":"Specified project or version (when supplied) not found"},"500":{"description":"Error retrieving project details"},"200":{"description":"Project Details Returned","content":{"application/json":{"schema":{"$ref":"#/components/schemas/projectDetailsResponse"}}}}}}},"/api/projects/v1/{projectUuid}/bom":{"get":{"summary":"Get BOM Data for Given Project","description":"Uses the provided projectUuid to identify the project for which to return the BOM details","tags":["Project Management"],"parameters":[{"name":"projectUuid","in":"path","required":true,"schema":{"type":"string","format":"uuid"}}],"responses":{"401":{"description":"Invalid or missing API Key or Invalid or missing username"},"404":{"description":"BOM data not found for projectUuid"},"500":{"description":"Error retrieving BOM data for project"},"200":{"description":"Project Details Returned","content":{"application/json":{"schema":{"$ref":"#/components/schemas/projectBOMResponse"}}}}}}},"/api/projects/v1/{projectUuid}/event":{"post":{"summary":"Send Event for Given Project","description":"Pushes a project-related event (like BOM updates or design deletions) to the Lowes event service.","tags":["Project Management"],"parameters":[{"name":"projectUuid","in":"path","required":true,"schema":{"type":"string","format":"uuid"}}],"requestBody":{"description":"Payload containing event details","required":true,"content":{"application/json":{"schema":{"$ref":"#/components/schemas/LowesEventRequest"}}}},"responses":{"200":{"description":"Event successfully processed"},"400":{"description":"Bad Request - Missing required fields or invalid enum values"},"401":{"description":"Invalid or missing API Key or UnAuthorized from Lowes Service"},"403":{"description":"Forbidden response from Lowes Service"},"500":{"description":"Error processing project event"}}}}}}